Package: fImport
Title: Rmetrics - Importing Economic and Financial Data
Version: 4052.89
Authors@R: c(person("Diethelm", "Wuertz", role="aut", comment = "original code")
	   , person("Tobias", "Setz", role = c("aut"), email = "tobias.setz@live.com")
	   , person("Yohan", "Chalabi", role = "aut")
	   , person(given = c("Georgi", "N."), family = "Boshnakov", 
                    role = c("cre", "aut"), email = "georgi.boshnakov@manchester.ac.uk",
		    comment = c(ORCID = "0000-0003-2839-346X")) )
Description: Provides a collection of utility functions 
    to download and manage data sets from the Internet or from other 
    sources.
Depends: R (>= 2.15.1), timeDate, timeSeries
Imports: methods, utils
Suggests: RUnit, rvest, xml2
LazyData: yes
License: GPL (>= 2)
URL: https://geobosh.github.io/fImportDoc/ (doc),
        https://CRAN.R-project.org/package=fImport,
        https://www.rmetrics.org
BugReports: https://r-forge.r-project.org/tracker/?atid=633&group_id=156&func=browse
NeedsCompilation: no
Packaged: 2025-12-18 12:38:38 UTC; georgi
Author: Diethelm Wuertz [aut] (original code),
  Tobias Setz [aut],
  Yohan Chalabi [aut],
  Georgi N. Boshnakov [cre, aut] (ORCID:
    <https://orcid.org/0000-0003-2839-346X>)
Maintainer: Georgi N. Boshnakov <georgi.boshnakov@manchester.ac.uk>
Repository: CRAN
Date/Publication: 2025-12-18 16:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 18:05:36 UTC; unix

oandaSeries <-
  function(symbols, from = NULL, to = Sys.timeDate(), nDaysBack = 366,  ...)
  {
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Easy to use download from www.oanda.com
    
    # Arguments:
    #   symbols - a character vector of symbol names
    #   from - from date
    #   to - to date
    #   nDaysBack - number of n-days back
    #   ... - arguments passed to the *Import()
    
    # Example:
    #   oandaSeries("USD/EUR")
    #   oandaSeries(c("USD/EUR", "USD/JPY"), nDaysBack = 10)
    
    # FUNCTION:
    
    # Download:
    if (is.null(from)) 
      from <- to - nDaysBack * 24 * 3600
    else
      from <- as.timeDate(from) 
    to <- as.timeDate(to)
    to <- trunc(to,"days")  
    # The maximum number of observations allowed by Oanda is 500
    # We need a loop to dowload the series sequencially 
    if ( (to-from) > 400)
    {
      getMore <- TRUE
      to2 <- from+399*24*3600
      X = oandaImport(query = symbols[1], from = from, to = to2, ...)@data
      while (getMore)
      {
        from2 <- to2+24*3600
        if ( (to-from2) < 400)
        {
          X <- rbind(X, oandaImport(query = symbols[1], 
                                    from = from2, to = to, ...)@data)
          getMore <- FALSE
        }
        else
        {
          to2 <- from2+399*24*3600
          X <- rbind(X, oandaImport(query = symbols[1], 
                                    from = from2, to = to2, ...)@data)
        }   
      }
    }
    else
      X = oandaImport(query = symbols[1], from = from, to = to, ...)@data
    names(X) <- symbols[1]  
    
    N = length(symbols)
    if (N > 1) {
      for (i in 2:N) {
        if ( (to-from) > 400)
        {
          getMore <- TRUE
          to2 <- from+399*24*3600
          X2 = oandaImport(query = symbols[i], from = from, to = to2, ...)@data
          while (getMore)
          {
            print(from2)
            from2 <- to2+24*3600
            if ( (to-from2) < 400)
            {
              X2 <- rbind(X2, oandaImport(query = symbols[i], 
                                          from = from2, to = to, ...)@data)
              getMore <- FALSE
            }
            else
            {
              to2 <- from2+399*24*3600
              X2 <- rbind(X2, oandaImport(query = symbols[i], 
                                          from = from2, to = to2, ...)@data)
            }   
          }
        }
        else
          X2 = oandaImport(query = symbols[i], from = from, to = to, ...)@data
        names(X2) <- symbols[i]
        X = cbind(X, X2)
      }
    }
    # Return Value:
    X
  }

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# FUNCTION:             DESCRIPTION:
#  fWEBDATA              Class Representation for WEB download
################################################################################


setClass("fWEBDATA", 
    representation(
        call = "call",
        data = "timeSeries",
        param = "character",
        title = "character",
        description = "character")  
)


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# INTERNAL:                 DESCRIPTION:
#  .getYahooData             Downloads time series data from yahoo finance
################################################################################


.getYahooData <-
function(
    symbol, 
    start = format(Sys.Date()-366, format = "%Y%m%d"),
    end = format(Sys.Date(), format = "%Y%m%d"), 
    freq = c("daily", "weekly", "monthly"),
    type = c("price", "split"), 
    adjust = TRUE,
    quiet = TRUE) 
{
    # A copy of a function implemented by Josh Ulrich
    
    # Description:
    #   Downloads time series data from yahoo finance
    
    # Arguments:
    #   symbol - character, instrument symbol
    #   start - numeric, starting date, in ISO-8601 format as ccyymmdd,
    #       default is series' first date)
    #   end - numeric, ending date, in ISO-8601 format as ccyymmdd,
    #       default is today
    #   freq - character, frequency of data
    #       either 'daily', 'weekly', 'monthly'
    #   type - character, either 'price' or 'split'
    #   adjust - ogical, adjusts the Open, High, Low, and Close prices 
    #       for dividends and splits, and adjusts Volume for dividends.
    
    # References:
    #   http://help.yahoo.com/l/us/yahoo/finance/quotes
    #   http://help.yahoo.com/l/us/yahoo/finance/quotes/quote-12.html
    #   http://ichart.finance.yahoo.com/x?s=MSFT&g=d&y=0&z=30000
    
    # Examples:
    #   ans = .getYahooData("IBM"); colnames(ans)
    #         "Date"  "Open" "High" "Low"    "Close"   "Volume" 
    #         "Unadj.Close"  "Div"  "Split"  "Adj.Div"  
    #   ans = .getYahooData("IBM", type = "split"); colnames(ans)
    #         "Date" "Div" "Split" "Adj.Div"
    
    # Note:
    #   DW:
    #       This is Josh's function "getYahooData()" for udjusted prices and 
    #       dividends+splits. We rename his function to ".getYahooData()" 
    #       leave it untouched, and use the wrappers around it ...
    #   JU:
    #       Thank you to Giorgio Beltrame for the URL to download dividends 
    #       _and_ splits, and for his correct adjustment procedure.
    #       Many thanks to Ion Georgiadis for helpful suggestions and testing.
    #   DW:
    #       Modifications:
    #           function renamed to .getYahooData
    #           description added
    #           examples added
    #           argument matching added
    #           attribute "update" added
    #           code shortened to max 80 characters per line
    
    # Author:
    #   Package: TTR
    #   Type: Package
    #   Title: Technical Trading Rules
    #   Version: 0.14-0
    #   Date: 2008-01-23
    #   Author: Josh Ulrich
    #   Maintainer: Josh Ulrich <josh.m.ulrich@gmail.com>
    #   Enhances: quantmod
    #   Description: Functions and data to construct technical trading rules  
    #   License: GPL-3 
    
    # FUNCTION:

    # Match Arguments:
    freq <- match.arg(freq)
    type <- match.arg(type)
    
    # Check Dates:
    if (missing(start)) {
        beg <- as.POSIXlt( "1900-01-01" )
    } else {
        beg <- as.POSIXlt( as.Date( as.character(start), "%Y%m%d" ) )
    }
    if (missing(end)) {
        end <- as.POSIXlt(Sys.Date())
    } else {
        end <- as.POSIXlt( as.Date( as.character( end ), "%Y%m%d" ) )
    }

    if( beg > end ) stop("Start date must be before end date.")
    if( beg > as.POSIXlt(Sys.Date()) ) stop("Start date is after today's date.")

    # Get freqeucy and type parameters
    freq <- match.arg( freq, c("daily","weekly","monthly") )
    type <- match.arg( type, c("price","split") )
    
    
    if(type == "price") {
        freq.url <- substr(freq,1,1)
    } else {
        freq.url <- "v"
        if(freq!="daily" & !quiet) 
            message("Only freq=\"daily\" data available for type=\"split\".\n",
                "Setting freq=\"daily\"...")
    }
    
    flush.console()

    if(type == "price") {

        if(adjust) {
    
          if(freq == "daily") {
    
            # Get price, dividend, and split data from 'beg' to present
            ohlc   <- .getYahooData(symbol, start, freq="daily", type = "price",
                adjust = FALSE, quiet = TRUE)
            divspl <- .getYahooData(symbol, start, freq="daily", type = "split",
                adjust = FALSE, quiet = TRUE)
            ohlc   <- merge(ohlc, divspl, by.col="Date", all = TRUE)
    
            # Create split adjustment ratio, (always = 1 if no splits exist)
            s.ratio <- rep(1, NROW(ohlc))
            if( !all( is.na(ohlc$Split) ) ) {
              # Start loop at most recent data
              for( i in NROW(ohlc):2 ) {
                if( is.na( ohlc$Split[i] ) ) {
                  s.ratio[i-1] <- s.ratio[i]
                } else {
                  s.ratio[i-1] <- s.ratio[i] * ohlc$Split[i]
                } 
              }
            }
    
            # Un-adjust dividends for Splits
            ohlc$Div <- ohlc$Adj.Div * ( 1 / s.ratio )
    
            # Create dividend adjustment ratio, 
            #   (always = 1 if no dividends exist)
            d.ratio <- rep(1, NROW(ohlc))
            if( !all( is.na(ohlc$Adj.Div) ) ) {
                # Start loop at most recent data
                for( i in NROW(ohlc):2 ) {
                    if( is.na( ohlc$Adj.Div[i] ) ) {
                        d.ratio[i-1] <- d.ratio[i]
                    } else {
                        d.ratio[i-1] <- d.ratio[i] * ( 1 - ohlc$Div[i] / 
                            ohlc$Close[i-1] ) 
                    } 
                }
            }
    
            # Adjust OHLC and volume
            ohlc$Unadj.Close <- ohlc$Close
            ohlc$Open   <- ohlc$Open  * d.ratio * s.ratio
            ohlc$High   <- ohlc$High  * d.ratio * s.ratio
            ohlc$Low    <- ohlc$Low   * d.ratio * s.ratio
            ohlc$Close  <- ohlc$Close * d.ratio * s.ratio
            ohlc$Volume <- ohlc$Volume * ( 1 / d.ratio )
    
            # Order columns
            ohlc <- ohlc[,c("Date","Open","High","Low","Close","Volume",
                            "Unadj.Close","Div","Split","Adj.Div")]
    
        } else {
            stop("Only freq=\"daily\" adjusted data is currently supported.")
        }
    
        # For other frequencies, get daily data and use a routine to
        # aggregate to desired frequency.
    
        } else {
    
            # Construct URL for 'beg' to 'end'
            url <- paste( 
                "http://ichart.finance.yahoo.com/table.csv?s=", symbol,
                "&a=", beg$mon, 
                "&b=", beg$mday, 
                "&c=", beg$year+1900,
                "&d=", end$mon, "&e=", end$mday, 
                "&f=", end$year+1900,
                "&g=", freq.url, "&ignore=.csv", sep="" )
        
            # Fetch data:
            ohlc <- read.table(url, header=TRUE, sep=",")
            ohlc$Date <- as.Date(as.character(ohlc$Date), "%Y-%m-%d")
            ohlc$Adj.Close <- NULL
    
        }

    } else {

        if(!quiet) 
            message("Unadjusted and adjusted dividend data are always returned.")

        # Construct URL for 'beg' to 'end'
        url <- paste( "http://ichart.finance.yahoo.com/x?s=", symbol,
                    "&a=", beg$mon, "&b=", beg$mday, "&c=", beg$year+1900,
                    "&d=", end$mon, "&e=", end$mday, "&f=", end$year+1900,
                    "&g=", freq.url, "&y=0&z=30000", sep="" )

        # Fetch data
        ohlc <- read.table(url, skip=1, sep=",", fill=TRUE, as.is=TRUE)
        div  <- data.frame( Date=   ohlc$V2[ohlc$V1=="DIVIDEND"],
                          Adj.Div=as.numeric(ohlc$V3[ohlc$V1=="DIVIDEND"]),
                          stringsAsFactors=FALSE )
        spl  <- data.frame( Date=   ohlc$V2[ohlc$V1=="SPLIT"],
                          Split=as.character(ohlc$V3[ohlc$V1=="SPLIT"]),
                          stringsAsFactors=FALSE )

        ohlc <- merge(div, spl, by.col="Date", all=TRUE)
        ohlc$Date <- as.Date(as.character(ohlc$Date), "%Y%m%d")

        # Create split adjustment ratio, (always = 1 if no splits exist)
        s.ratio <- rep(1, NROW(ohlc))
        if(NROW(spl)!=0) {
            ohlc$Split <- sub(":","/", ohlc$Split)
            ohlc$Split <- 1 / sapply( parse( text=ohlc$Split ), eval )
            # Start loop at most recent data
            for( i in NROW(ohlc):2 ) {
                if( is.na( ohlc$Split[i] ) ) {
                    s.ratio[i-1] <- s.ratio[i]
                } else {
                    s.ratio[i-1] <- s.ratio[i] * ohlc$Split[i]
                } 
            }   
        }

        # Un-adjust dividends for Splits
        ohlc$Div <- ohlc$Adj.Div * ( 1 / s.ratio )
        ohlc$Split <- as.numeric(ohlc$Split)

        # Order data columns
        ohlc <- ohlc[,c("Date","Div","Split","Adj.Div")]

        # Return (empty) data
        if(NROW(ohlc)==0) return(ohlc)
    }

    # Order Dates, and only return requested data (drop 'end' to present)
    ohlc <- ohlc[order(ohlc$Date),]
    row.names(ohlc) <- 1:NROW(ohlc)
    ohlc <- ohlc[ ( ohlc$Date >= as.Date(beg) & ohlc$Date <= as.Date(end) ), ]

    ### Check to see if supplied dates occur in data set
    if( max(ohlc$Date) != as.Date(end) ) {
        if(!quiet) message("End date out of range, "  , max(ohlc$Date), 
            " is last available date.")
    }
    if( min(ohlc$Date) != as.Date(beg) ) {
        if(!quiet) message("Start date out of range, ", min(ohlc$Date), 
            " is first available date.")
    }
       
    # Add Attributes:
    attr(ohlc, "update") <- format(Sys.time())

    # Return Value:
    return(ohlc)
}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  oandaImport           Downloads market data from www.oanda.com
#  oandaSeries           Easy to use download from www.oanda.com
################################################################################


oandaImport <-
  function(query, file = "tempfile", source = NULL,
           frequency = "daily",
           from = NULL, to = Sys.timeDate(), nDaysBack = 366,
           save = FALSE, sep = ";", try = TRUE)
  {
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Downloads market data from www.oanda.com
    
    # Example:
    #   oandaImport("USD/EUR")
    
    # Value:
    #   An One Column data frame with row names denoting the dates
    #   given in the POSIX format "%Y%m%d". The column lists the
    #   downloaded data records.
    
    # FUNCTION:
    
    # Settings:
    stopifnot(length(query) == 1)
    
    # Check:
    stopifnot(frequency == "daily")
    
    # Source:
    if (is.null(source))
      source <- "http://www.oanda.com/currency/historical-rates/download?&"
    
    # Download:
    if (try) {
      # Try for Internet Connection:
      z <- try(oandaImport(query, file, source, frequency, from, to,
                           nDaysBack, save, sep, try = FALSE))
      if (inherits(z, "try-error") || inherits(z, "Error")) {
        return("No Internet Access")
      } else {
        return(z)
      }
    } else {
      # Download File:
      if (is.null(to)) to <- Sys.timeDate()
      to <-  trunc(as.timeDate(to),"days")
      
      if (is.null(from)) {
        if (is.null(nDaysBack)) {
          stop("The \"from\" and \"nDaysBack\" arguments cannot be NULL at the same time.")
        } else {
          from <- to - nDaysBack*24*3600
        }
      }
      from <- trunc(as.timeDate(from),"days")
      
      from.date <- as.character(from)
      to.date <- as.character(to)
      
      ccy.pair <- strsplit(toupper(query),"/")[[1]]
      tmp <- tempfile()
      
      url <- paste0(source, 
                    "quote_currency=", ccy.pair[1], 
                    "&end_date=", to.date, "&start_date=", from.date, 
                    "&period=daily", "&display=absolute", "&rate=0", 
                    "&data_range=", "c", "&price=mid", "&view=table", 
                    "&base_currency_0=", ccy.pair[2],
                    "&base_currency_1=", "&base_currency_2=", "&base_currency_3=", "&base_currency_4=",
                    "&download=csv")
      
      download.file(url=url, destfile=tmp)
      # add an EOL to the file to avoid the warning message
      #cat("\n",file=tmp,append=TRUE)
      
      ## Compose Time Series:
      # fx <- read.csv(tmp, skip = 4, as.is = TRUE, header = TRUE)
      
      fl <- scan(tmp, what = "", sep = "\n", quote="\"")
      begin <- grep(paste(ccy.pair,collapse="/"),fl)
      fl <- fl[begin:length(fl)]
      
      fx <- matrix(unlist(strsplit(fl,split=",")), nrow=length(fl), byrow=TRUE)[-1,1:2]
      dates <- !is.na(as.Date(fx[,1]))
      fx <- fx[dates,]
      
      data <- rev(as.numeric(fx[,2]))
      charvec <- rev(as.character((fx[,1])))
      X <- timeSeries(data, charvec, units = query)
    }
    
    # Save to file:
    if (save) {
      write.table(as.data.frame(X), file = file, sep = sep)
    } else {
      unlink(file)
    }
    
    # Result:
    ans <- new("fWEBDATA",
               call = match.call(),
               param = c(
                 "Instrument" = query,
                 "Frequency " = frequency),
               data = X,
               title = "Data Import from www.oanda.com",
               description = description() )
    
    # Return Value:
    ans
  }


# ------------------------------------------------------------------------------
oandaSeries <-
  function(symbols, from = NULL, to = Sys.timeDate(), nDaysBack = 366, ...)
  {
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Easy to use download from www.oanda.com
    
    # Arguments:
    #   symbols - a character vector of symbol names
    #   from - from date
    #   to - to date
    #   nDaysBack - number of n-days back
    #   ... - arguments passed to the *Import()
    
    # Example:
    #   oandaSeries("USD/EUR")
    #   oandaSeries(c("USD/EUR", "USD/JPY"), nDaysBack = 10)
    
    # FUNCTION:
    
    # Download:
    X <- oandaImport(query = symbols[1],
                     from = from, to = to, nDaysBack=nDaysBack, ...)@data
    N <- length(symbols)
    if (N > 1) {
      for (i in 2:N) {
        X <- merge(X, oandaImport(query = symbols[i],
                                  from = from, to = to, nDaysBack=nDaysBack, ...)@data)
      }
    }
    
    # Return Value:
    X
  }

################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  yahooImport           Downloads market data from chart.yahoo.com
#  yahooSeries           Easy to use download from chart.yahoo.com
################################################################################


yahooImport <-
  function (query, file = "tempfile", source = NULL,
            frequency = c("daily", "weekly", "monthly"),
            from = NULL, to = Sys.timeDate(), nDaysBack = 366,
            save = FALSE, sep = ";", try = TRUE)
  {
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Downloads market data from Yahoo's web site
    
    # Notes:
    #   Requires: fields() cuts a string in fields
    #   Yahoo Token Description:
    #   s     Selected Ticker-Symbol
    #   a     First Quote starts with Month (mm): 0-11, Jan-Dec
    #   b     First Quote starts with Day (dd)
    #   c     First Quote starts with Year: as CCYY
    #   d     Last Quote ends with Month (mm): 0-11, Jan-Dec
    #   e     Last Quote ends with Day (dd)
    #   f     Last Quote ends with Year (yy): as CCYY
    #   r     Aggregation Level
    #   z     Selected Ticker-Symbol [optional]
    #   IBM SHARES, test 19/20 century change 01-12-1999 -- 31-01-2000:
    #   "s=IBM&a=11&b=1&c=1999&d=0&e=31&f=2000&g=d&x=.csv"
    
    # Examples:
    #   yahooImport("IBM", nDaysBack = 10)
    #   yahooImport(symbols = c("^DJI", "IBM"))
    #   yahooImport(symbols = c("^DJI", "IBM"), frequency = "weekly")
    #   yahooImport(frequency = "monthly", nDaysBack = 366)
    
    # FUNCTION:
    
    # Check:
    stopifnot(length(query) == 1)
    
    # Match Arguments:
    freq <- match.arg(frequency)
    aggregation <- substr(freq, 1, 1)
    
    # Automatic Selection of From / To:
    if (is.null(to)) to <- Sys.timeDate()
    to <-  trunc(as.timeDate(to),"days")
    
    if (is.null(from)) {
      if (is.null(nDaysBack)) {
        stop("The \"from\" and \"nDaysBack\" arguments cannot be NULL at the same time.")
      } else {
        from <- to - nDaysBack*24*3600
      }
    }
    from <- trunc(as.timeDate(from),"days")
    
    from <- as.character(from)
    to <- as.character(to)
    
    # Extract Atoms - From:
    yearFrom <- substring(from, 1, 4)
    monthFrom <- as.character(as.integer(substring(from, 6, 7))-1)
    dayFrom <- substring(from, 9, 10)
    
    # Extract Atoms - To:
    yearTo <- substring(to, 1, 4)
    monthTo <- as.character(as.integer(substring(to, 6, 7))-1)
    dayTo <- substring(to, 9, 10)
    
    # Compose Query:
    Query <- paste("s=", query, "&a=", monthFrom, "&b=", dayFrom,
                   "&c=", yearFrom, "&d=", monthTo, "&e=", dayTo, "&f=", yearTo,
                   "&g=", aggregation, "&q=q&y=0&z=", query, "&x=.csv", sep = "")
    
    # Source:
    if (is.null(source))
      source <- "http://chart.yahoo.com/table.csv?"
    
    # Download:
    if (try) {
      # First try if the Internet can be accessed:
      z <- try(yahooImport(query, file, source, frequency, from, to,
                           nDaysBack, save, sep, try = FALSE))
      if (inherits(z, "try-error") || inherits(z, "Error")) {
        return("No Internet Access")
      } else {
        return(z)
      }
    } else {
      # Download File:
      url <- paste(source, Query, sep = "")
      tmp <- tempfile()
      download.file(url = url, destfile = tmp)
      
      # Read data and revert:
      mat <- read.table(tmp, header = TRUE, sep = ",")
      X <- rev(as.timeSeries(mat))
      colnames(X) <- paste(sub("\\^","",query), colnames(X), sep = ".")
    }
    
    # Save to file:
    if (save) {
      write.table(as.data.frame(X), file = file, sep = sep)
    } else {
      unlink(file)
    }
    
    # Result:
    ans <- new("fWEBDATA",
               call = match.call(),
               param = c(
                 "Instrument" = query,
                 "Frequency " = freq),
               data = X,
               title = "Data Import from www.yahoo.com",
               description = description() )
    
    # Return Value:
    ans
  }


# ------------------------------------------------------------------------------
yahooSeries <-
  function(symbols, from = NULL, to = Sys.timeDate(), nDaysBack = 366, ...)
  {
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Downloads easily time series data from Yahoo
    
    # Arguments:
    #   symbols - a character vector of symbol names
    #   from - from date
    #   to - to date
    #   nDaysBack - number of n-days back
    #   ... - arguments passed to the *Import()
    
    # Examples:
    #   yahooSeries("IBM", nDaysBack = 10)
    #   yahooSeries("IBM", frequency = "weekly")
    #   yahooSeries(c("^DJI", "IBM"))
    #   yahooSeries(c("^DJI", "IBM"), frequency = "monthly")
    
    # FUNCTION:
    
    # Download:
    X <- yahooImport(query = symbols[1],
                     from = from, to = to, nDaysBack=nDaysBack, ...)@data
    N <- length(symbols)
    if (N > 1) {
      for (i in 2:N) {
        Y <- yahooImport(query = symbols[i],
                         from = from, to = to, nDaysBack=nDaysBack, ...)@data
        X <- merge(X, Y)
      }
    }
    
    # Return Value:
    X
  }


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  show,fWEBDATA         S4 Show Method for WEB downloaded data
################################################################################


setMethod("show", signature(object = "fWEBDATA"), definition =
    function(object)
{
    # A function implemented by Diethelm Wuertz

    # FUNCTION:

    # Unlike print the argument for show is 'object'.
    x = object

    # Title:
    cat("\nTitle:\n ", object@title, "\n", sep = "")

    # Parameter:
    cat("\nParameter:\n ")
    param = cbind(object@param)
    colnames(param) = "Value:"
    print(param, quotes = FALSE)

    # Description:
    cat("\nDescription:\n ", object@description, sep = "")
    cat("\n\n")

    # Return Value:
    invisible()
})


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:               DESCRIPTION:
#  read.lines              A synonyme function call to readLines
################################################################################


# wrapper function of read.lines to have consistent function names as
# described in ebook.


read.lines <- 
    function(con = stdin(), n = -1L, ok = TRUE, warn = FALSE,
    encoding = "unknown")
{
    readLines(con = con, n = n, ok = ok, warn = warn, encoding = encoding)
}

################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


###############################################################################
# FUNCTION:               DESCRIPTION:
#  read.links              Uses the links browser to read from a web page
###############################################################################


read.links <-
    function (url, intern = TRUE, bin = NULL, pipe = FALSE, ...) 
{
    # A function implemented by Diethelm Wuertz and Yohan Chalabi

    # Description:
    #   Uses the links browser to read from a web page
    
    # Example:
    #   read.lynx("www.rmetrics.org", bin = "C:/cygwin/bin/lynx.exe")
    
    # FUNCTION:

    # Paste Arguments:
    ldots <- list(...)
    args <- if (length(ldots)) 
        paste(paste("-", names(ldots), "=", sep = ""), ldots, 
            sep = "", collapse = " ")
    else ""
    cmd <- if (is.null(bin)) 
        paste("links", args, "-dump", shQuote(url))
    else paste(bin, args, "-dump", shQuote(url))
    ans <- if (pipe) 
        pipe(cmd)
    else 
        system(cmd, intern = intern)
    ans
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# FUNCTION:             DESCRIPTION:
#  .dQuote.ascii         Creates a temporary function to quote a string
#  .xls2csv              Converts a xls file into acsv file
#  .read.xls             reads low level a xls files
################################################################################


# Package: gdata
# Title: Various R programming tools for data manipulation
# Description: Various R programming tools for data manipulation
# Version: 2.4.2
# Date: 2008-05-12
# Author: Gregory R. Warnes and Gregor Gorjanc.
# Maintainer: Gregory Warnes <gregory_warnes@urmc.rochester.edu>
# License: GPL-2


.dQuote.ascii <-
function(x)
{
    # Borrowed from contributed Package 'gdata'

    # FUNCTION:

    # Creating a temporary function to quote the string
    paste('"', x,'"', sep = '')
}


#-------------------------------------------------------------------------------


.xls2csv <-
    function(xls, sheet = 1, verbose = FALSE, ..., perl = "perl")
{
    # Borrowed from contributed Package 'gdata'

    # FUNCTION:

    # Directories:
    package.dir <- path.package('fImport')
    perl.dir <- file.path(package.dir,'perl')

    # Files:
    tf <- NULL
    if (substring(xls, 1, 7) == "http://") {
        tf <- paste(tempfile(), "xls", sep = ".")
            if(verbose)
                cat("Downloading",
                    .dQuote.ascii(xls), " to ",
                    .dQuote.ascii(tf), "...\n")
            else
          cat("Downloading...\n")
        download.file(xls, tf, mode = "wb")
        cat("Done.\n")
        xls <- tf
    }

    if(file.access(xls, 4)!=0)
        stop("Unable to read xls file '", xls, "'." )

    .xls2csv <- file.path(perl.dir,'xls2csv.pl')
    csv <- paste(tempfile(), "csv", sep = ".")

    # Execution command
    cmd <- paste(perl, .xls2csv, .dQuote.ascii(xls), .dQuote.ascii(csv),
        sheet, sep=" ")

    if(verbose)
      {
        cat("\n")
        cat("Converting xls file\n")
        cat("   ", .dQuote.ascii(xls), "\n")
        cat("to csv file \n")
        cat("   ", .dQuote.ascii(csv), "\n")
        cat("... \n\n")
      }
      else
        cat("Converting xls file to csv file... ")

    # Do the translation
    if(verbose)  cat("Executing ", cmd, "... \n\n")
    results <- system(cmd, intern=!verbose)
    if (verbose) cat("Done.\n\n")


    if(file.access(csv, 4)!=0)
        stop("Unable to read translated csv file '", csv, "'." )
    cat("Done.\n")


    # Prepare for cleanup now, in case of error reading file
    file(csv)
}


# ------------------------------------------------------------------------------


.read.xls <-
    function(xls, sheet = 1, verbose = FALSE, pattern, ..., perl = "perl")
{
    # Borrowed from contributed Package 'gdata'

    # FUNCTION:

    # Connection:
    con <- tfn <- NULL
    on.exit({
        if (inherits(con, "connection") && isOpen(con)) close(con)
        if (file.exists(tfn)) file.remove(tfn)})

    # Expand file path, translating ~ to user's home directory, etc.
    xls <- path.expand(xls)


    # Translate from xls to csv format (returns csv file name)
    con <- .xls2csv(xls, sheet, verbose=verbose, ..., perl = perl)

    # Load the csv file
    open(con)
    tfn <- summary(con)$description
    if (missing(pattern)) {
        if(verbose)
            cat("Reading csv file ", .dQuote.ascii(tfn), "...\n")
        else
            cat("Reading csv file... ")
        retval <- read.csv(con, ...)
        cat("Done.\n")
    } else {
        cat("Searching for lines containing pattern ", pattern, "... ")
        idx <- grep(pattern, readLines(con))
        if (length(idx) == 0) {
            warning("pattern not found")
            return(NULL)
        }
        cat("Done.\n")

        seek(con, 0)

        if(verbose)
            cat("Reading csv file ", .dQuote.ascii(tfn), "...\n")
        else
            cat("Reading csv file... ")
        retval <- read.csv(con, skip = idx[1]-1, ...)
        cat("Done.\n")
    }

    # Return Value:
    retval
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


################################################################################
# FUNCTION:               DESCRIPTION:
#  composeURL              Compose URL from partial strings
#  indexGrep               Greps Lines given a pattern
################################################################################


composeURL <- 
    function(..., prefix = "http://")
{
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Compose URL from partial strings
    
    # FUNCTION:
    
    # Return Value:
    paste(prefix, ..., sep = "")
}


# ------------------------------------------------------------------------------


indexGrep <- 
    function(pattern, x, ...)
{
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Greps Lines given a pattern
    
    # FUNCTION:
    
    # Return Value:
    x[grep(pattern, x, ...)]
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# FUNCTION:             DESCRIPTION:
#  oandaImport           Downloads market data from www.oanda.com
#  oandaSeries           Easy to use download from www.oanda.com
################################################################################


oandaImport <-
    function(query, file = "tempfile", source = NULL,
    frequency = "daily",
    from = NULL, to = Sys.timeDate(), nDaysBack = 366,
    save = FALSE, sep = ";", try = TRUE)
{
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Downloads market data from www.oanda.com

    # Example:
    #   oandaImport("USD/EUR")

    # Value:
    #   An One Column data frame with row names denoting the dates
    #   given in the POSIX format "%Y%m%d". The column lists the
    #   downloaded data records.

    # FUNCTION:

    # Settings:
    stopifnot(length(query) == 1)

    # Check:
    stopifnot (frequency == "daily")

    # Source:
    if (is.null(source))
        source <- "http://www.oanda.com/convert/fxhistory?lang=en&"

    # Download:
    if (try) {
        # Try for Internet Connection:
        z <- try(oandaImport(query, file, source, frequency, from, to,
            nDaysBack, save, sep, try = FALSE))
        if (inherits(z, "try-error") || inherits(z, "Error")) {
            return("No Internet Access")
        } else {
            return(z)
        }
    } else {
        # Download File:
    to <- as.timeDate(to)
        to = trunc(to, "days")
    if (is.null(from))
            from = to - nDaysBack * 24 * 3600
    else
        from <- as.timeDate(from)
        from.date <- format(timeDate(from),
            "date1=%m%%2F%d%%2F%y&")
        to.date <- format(timeDate(to),
            "date=%m%%2F%d%%2F%y&date_fmt=us&")
        ccy.pair <- strsplit(toupper(query),"/")[[1]]
        tmp <- tempfile()
        download.file(
            paste(source, from.date, to.date, "exch=", ccy.pair[1],
                "&expr2=", ccy.pair[2], "&margin_fixed=0&SUBMIT=Get+Table&",
                "format=CSV&redirected=1", sep = ""),
            destfile = tmp)
    # add an EOL to the file to avoid the warning message
    cat("\n",file=tmp,append=TRUE)

        # Compose Time Series:
        fx <- readLines(tmp)
        fx <- unlist(strsplit(
            gsub("<PRE>|</PRE>", "",
            fx[(grep("PRE", fx)[1]):(grep("PRE",fx)[2])]), ","))
        fx = matrix(fx, byrow = TRUE, ncol = 2)
        data = as.numeric(fx[, 2])
        time = fx[, 1]
        charvec = paste(substr(time, 7, 10), substr(time, 1, 2),
            substr(time, 4, 5), sep = "-")
        X = timeSeries(data, charvec, units = query)
    }

    # Save to file:
    if (save) {
        write.table(as.data.frame(X), file = file, sep = sep)
    } else {
        unlink(file)
    }

    # Result:
    ans <- new("fWEBDATA",
        call = match.call(),
        param = c(
            "Instrument" = query,
            "Frequency " = frequency),
        data = X,
        title = "Data Import from www.oanda.com",
        description = description() )

    # Return Value:
    ans
}


# ------------------------------------------------------------------------------


oandaSeries <-
    function(symbols, from = NULL, to = Sys.timeDate(), nDaysBack = 366,  ...)
{
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Easy to use download from www.oanda.com

    # Arguments:
    #   symbols - a character vector of symbol names
    #   from - from date
    #   to - to date
    #   nDaysBack - number of n-days back
    #   ... - arguments passed to the *Import()

    # Example:
    #   oandaSeries("USD/EUR")
    #   oandaSeries(c("USD/EUR", "USD/JPY"), nDaysBack = 10)

    # FUNCTION:

    # Download:
    if (is.null(from)) 
        from <- to - nDaysBack * 24 * 3600
    else
    from <- as.timeDate(from) 
    to <- as.timeDate(to)
    to <- trunc(to,"days")  
    # The maximum number of observations allowed by Oanda is 500
    # We need a loop to dowload the series sequencially 
    if ( (to-from) > 400)
    {
    getMore <- TRUE
    to2 <- from+399*24*3600
    X = oandaImport(query = symbols[1], from = from, to = to2, ...)@data
    while (getMore)
        {
        from2 <- to2+24*3600
        if ( (to-from2) < 400)
            {
            X <- rbind(X, oandaImport(query = symbols[1], 
                from = from2, to = to, ...)@data)
            getMore <- FALSE
            }
        else
            {
            to2 <- from2+399*24*3600
            X <- rbind(X, oandaImport(query = symbols[1], 
                from = from2, to = to2, ...)@data)
            }   
        }
    }
    else
        X = oandaImport(query = symbols[1], from = from, to = to, ...)@data
    names(X) <- symbols[1]  

    N = length(symbols)
    if (N > 1) {
        for (i in 2:N) {
       if ( (to-from) > 400)
        {
        getMore <- TRUE
        to2 <- from+399*24*3600
        X2 = oandaImport(query = symbols[i], from = from, to = to2, ...)@data
        while (getMore)
            {
            print(from2)
            from2 <- to2+24*3600
            if ( (to-from2) < 400)
                {
                X2 <- rbind(X2, oandaImport(query = symbols[i], 
                    from = from2, to = to, ...)@data)
                getMore <- FALSE
                }
            else
                {
                to2 <- from2+399*24*3600
                X2 <- rbind(X2, oandaImport(query = symbols[i], 
                    from = from2, to = to2, ...)@data)
                }   
            }
        }
        else
            X2 = oandaImport(query = symbols[i], from = from, to = to, ...)@data
        names(X2) <- symbols[i]
            X = cbind(X, X2)
        }
    }
    # Return Value:
    X
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


################################################################################
# FUNCTION:             DESCRIPTION:
#  fredImport            Downloads market data from research.stlouisfed.org
#  fredSeries            Easy to use download from research.stlouisfed.org
################################################################################


fredImport <- function(query, file = "tempfile", source = NULL,
                       frequency = "daily",
                       from = NULL, to = Sys.timeDate(), nDaysBack = NULL,
                       save = FALSE, sep = ";", try = TRUE) {
    ## A function implemented by Diethelm Wuertz
    ##     Modified by GNB to work with html (using html2 and rvest).

    # Description:
    #   Downloads Monthly Market Data, Indices and Benchmarks from
    #   St. Louis FED, "research.stlouisfed.org".

    # Value:
    #   An one column data frame with row names denoting the dates
    #   given in the POSIX format "%Y%m%d". The column lists the
    #   downloaded data records.

    # Examples:
    #   fredImport("DPRIME")

    # Notes:
    #   This function is written for one-column daily data sets.
    #   Some example data sets include:
    #     DEXUSEU   U.S. / Euro Foreign Exchange Rate
    #     DEXSZUS   Switzerland / U.S. Foreign Exchange Rate
    #     DGS1      1-Year Treasury Constant Maturity Rate
    #     DPRIME    Bank Prime Loan Rate

    # FUNCTION:

    # Settings:
    stopifnot(length(query) == 1)

    # Source"
    if (is.null(source))
        ## 2024-09-19 was:  source = "http://research.stlouisfed.org/fred2/series/"
        source <- "https://fred.stlouisfed.org"

    # Check:
    if (frequency != "daily")
        stop("Only daily data records are supported!")

    # Download:
    if (try) {
        ## Try for Internet Connection (recursive call!):
        z = try(fredImport(query, file, source, frequency, from, to,
                           nDaysBack, save, sep, try = FALSE))
        if (inherits(z, "try-error") || inherits(z, "Error"))
            return("No Internet Access or another error")
        else
            return(z)
    }
    
                     # Download File:
                     # was:
                     #     queryFile = paste(query, "/downloaddata/", query, ".txt", sep = "")
                     #     url = paste(source, queryFile, sep = "")
    queryFile <- paste0("/data/", query)
    url <- paste0(source, queryFile)

    tmp <- tempfile()
    download.file(url = url, destfile = tmp)

                     # # Scan the file:
                     # was:
                     #     x1 = scan(tmp, what = "", sep = "\n")
                     #
                     #     # Extract dates ^19XX and ^20XX:
                     #     x2 = x1[regexpr(pattern="^[12][90]", x1, perl=TRUE) > 0]
                     #     x1 = x2[regexpr(pattern=" .$", x2, perl=TRUE) < 0]
                     #
                     #     # Compose Time Series:
                     #     data <- matrix(
                     #       as.numeric(substring(x1, 11, 999)), byrow = TRUE, ncol = 1)
                     #     charvec <- substring(x1, 1, 10)
    if(!requireNamespace("xml2") || !requireNamespace("rvest"))
        stop("this function requires packages 'xml2' and 'rvest',please install them")
    xml2 <- xml2::read_html(tmp, encoding = "UTF-8")

    tbls <- rvest::html_table(xml2)
    datatbl <- tbls[[2]]

                     # VALUE is character since '.' stands for NA;
                     # TODO (GNB):
                     #      maybe should be defensive here - what happens
                     #          if there are no missing values?
                     #          will VALUE be still character?
    datatbl$VALUE[datatbl$VALUE == "."] <- NA
    datatbl$VALUE <- as.numeric(datatbl$VALUE)

    data <- matrix(datatbl$VALUE, ncol = 1)
    charvec <- datatbl$DATE

    X <- timeSeries(data, charvec, units = query)

    ## Time Window:
    if (is.null(to))
        to <- Sys.timeDate()
    to <- trunc(as.timeDate(to), "days")

    if (is.null(from)) {
        from <- if (is.null(nDaysBack))
                    start(X)
                else
                    from <- to - nDaysBack * 24 * 3600
    }
    from <- trunc(as.timeDate(from), "days")

    X <- window(X, from, to)


    ## Save to file:
    if (save) {
        write.table(as.data.frame(X), file = file, sep = sep)
    } else {
        unlink(file)
    }

    # Result:
    ## TODO (GNB): could do better - tbls[[1]] contains header information
    ans <- new("fWEBDATA",
               call = match.call(),
               param = c(
                 "Instrument" = query,
                 "Frequency " = frequency),
               data = X,
               title = "Data Import from research.stlouisfed.org",
               description = description() )

    # Return Value:
    ans
}


# ------------------------------------------------------------------------------
fredSeries <-
  function(symbols, from = NULL, to = Sys.timeDate(), nDaysBack = 366, ...)
  {
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Downloads easily time series data from St. Louis FRED

    # Arguments:
    #   symbols - a character vector of symbol names
    #   from - from date
    #   to - to date
    #   nDaysBack - number of n-days back
    #   ... - arguments passed to the *Import()

    # Examples:
    #   fredSeries("DPRIME")[1:10, ]

    # FUNCTION:

    # Download:
    X <- fredImport(query = symbols[1],
                    from = from, to = to, nDaysBack=nDaysBack, ...)@data
    N <- length(symbols)
    if (N > 1) {
      for (i in 2:N) {
        X <- merge(X, fredImport(query = symbols[i],
                                 from = from, to = to, nDaysBack=nDaysBack, ...)@data)
      }
    }

    # Return Value:
    X
  }


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA


###############################################################################
# FUNCTION:               DESCRIPTION:
#  read.lynx               Uses the lynx browser to read from a web page
###############################################################################


read.lynx <- 
    function(url, intern = TRUE, bin = NULL, pipe = FALSE, ...) 
{
    # A function implemented by Diethelm Wuertz and Yohan Chalabi

    # Description:
    #   Uses the lynx browser to read from a web page
    
    # Example:
    #   read.lynx("www.rmetrics.org", bin = "C:/cygwin/bin/lynx.exe")
    
    # FUNCTION:

    # Paste Arguments:
    ldots <- list(...)
    args <-
        if (length(ldots))
            paste(paste("-", names(ldots) , "=", sep = ""), ldots, sep = "", 
                collapse = " ")
        else
            ""

    # Compose Command:
    cmd <-
        if (is.null(bin))
            paste("lynx", args, "-dump -dont_wrap_pre", shQuote(url))
        else
            paste(bin, args, "-dump -dont_wrap_pre", shQuote(url))

    # Download URL:
    ans <-
        if (pipe)
            pipe(cmd)
        else
            system(cmd, intern = intern)

    # Return Value:
    ans
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# FUNCTION:               DESCRIPTION:
#  dataSplit               Splits data matrix from a downloaded file
#  charvecSplit            Splits charvec vector from a downloaded file
################################################################################


dataSplit <- 
function (x, split=" ", col=-1) 
{
    # A function implemented by Diethelm Wuertz
    
    # Description
    #   Splits data matrix from a downloaded file
    
    # FUNCTION
    
    # Split Function:
    FUN = function(x, split, col) {
        unlist(strsplit(x, split))[col]
    }
    
    # Split Data:
    data = unlist(lapply(x, FUN, split = split, col = col))
    data = matrix(as.numeric(data), byrow = TRUE, nrow = length(x))
    
    # Return Value:
    data
}


# ------------------------------------------------------------------------------


charvecSplit <-
function (x, split=" ", col=1, format="%F") 
{
    # A function implemented by Diethelm Wuertz
    
    # Description
    #   Splits charvec vector from a downloaded file
    
    # FUNCTION
    
    # Split Function:
    FUN = function(x, split, col) {
        unlist(strsplit(x, split))[col]
    }
    
    # Split Date Character Vector:
    charvec = unlist(lapply(x, FUN, split = split, col = col))
    charvec = format(strptime(charvec, format = format))
    
    # Return Value:
    charvec
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA


###############################################################################
# FUNCTION:               DESCRIPTION:
#  dataSplit               Splits a data matrix from a downloaded file
#  charvecSplit            Splits a charvec vector from a downloaded file
#  stringSplit             Splits a string vector from a downloaded file
###############################################################################


dataSplit <- 
  function (x, split=" ", col=-1) 
{
  # A function implemented by Diethelm Wuertz
  
  # Description:
  #   Splits a data matrix from a downloaded file
  
  # Arguments:
  #   x - a vector of data records to be splitted
  #   split - splitting separator
  #   col - columns to be extracted
  
  # FUNCTION
  
  # Split Function:
  FUN <- function(x, split, col) {
      unlist(strsplit(x, split))[col] }
  
  # Split Data Set:
  data <- unlist(lapply(x, FUN, split = split, col = col))
  data <- gsub("NA", "NaN", data)
  data <- matrix(as.numeric(data), byrow = TRUE, nrow = length(x))
  
  # Return Value:
  data
}


# -----------------------------------------------------------------------------


charvecSplit <-
  function (x, split=" ", col=1, format="%F") 
{
  # A function implemented by Diethelm Wuertz
  
  # Description:
  #   Splits a charvec vector from a downloaded file
  
  # Arguments:
  #   x - a vector of data records to be splitted
  #   split - splitting separator
  #   col - columns to be extracted
  #   format - date format, by default "%F"
  
  # FUNCTION:
  
  # Split Function:
  FUN <- function(x, split, col) {
      unlist(strsplit(x, split))[col] }
  
  # Split Date Character Vector:
  charvec <- unlist(lapply(x, FUN, split = split, col = col))
  charvec <- format(strptime(charvec, format = format))
  
  # Return Value:
  charvec
}


# -----------------------------------------------------------------------------


stringSplit <-
  function (x, split = " ", col = NULL) 
{
  # A function implemented by Diethelm Wuertz
  
  # Description:
  #   Splits a string vector from a downloaded file
  
  # Arguments:
  #   x - a vector of data records to be splitted
  #   split - splitting separator
  #   col - columns to be extracted
  #   format - date format, by default "%F"
  
  # FUNCTION:
  
  # Split Function:
  FUN <- function(x, split, col) {
      unlist(strsplit(x, split))[col] }
  
  # Split String Vector:    
  data <- unlist(lapply(x, FUN, split = split, col = col))
  data <- matrix(data, byrow = TRUE, nrow = length(x))
  
  # eturn Value:
  data
}


###############################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General
# Public License along with this library; if not, write to the
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# FUNCTION:             DESCRIPTION:
#  yahooImport           Downloads market data from chart.yahoo.com
#  yahooSeries           Easy to use download from chart.yahoo.com
################################################################################


yahooImport <-
    function (query, file = "tempfile", source = NULL,
    frequency = c("daily", "weekly", "monthly"),
    from = NULL, to = Sys.timeDate(), nDaysBack = 366,
    save = FALSE, sep = ";", try = TRUE)
{
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Downloads market data from Yahoo's web site

    # Notes:
    #   Requires: fields() cuts a string in fields
    #   Yahoo Token Description:
    #   s     Selected Ticker-Symbol
    #   a     First Quote starts with Month (mm): 0-11, Jan-Dec
    #   b     First Quote starts with Day (dd)
    #   c     First Quote starts with Year: as CCYY
    #   d     Last Quote ends with Month (mm): 0-11, Jan-Dec
    #   e     Last Quote ends with Day (dd)
    #   f     Last Quote ends with Year (yy): as CCYY
    #   r     Aggregation Level
    #   z     Selected Ticker-Symbol [optional]
    #   IBM SHARES, test 19/20 century change 01-12-1999 -- 31-01-2000:
    #   "s=IBM&a=11&b=1&c=1999&d=0&e=31&f=2000&g=d&x=.csv"

    # Examples:
    #   yahooImport("IBM", nDaysBack = 10)
    #   yahooImport(symbols = c("^DJI", "IBM"))
    #   yahooImport(symbols = c("^DJI", "IBM"), frequency = "weekly")
    #   yahooImport(frequency = "monthly", nDaysBack = 366)

    # FUNCTION:

    # Check:
    stopifnot(length(query) == 1)

    # Match Arguments:
    freq = match.arg(frequency)
    aggregation = substr(freq, 1, 1)

    # Automatic Selection of From / To:
    if (is.null(from) & is.null(to)) {
        to = Sys.timeDate()
        from = as.character(to - nDaysBack*24*3600)
        to = as.character(to) }

    # Extract Atoms - From:
    yearFrom = substring(from, 1, 4)
    monthFrom = as.character(as.integer(substring(from, 6, 7))-1)
    dayFrom = substring(from, 9, 10)

    # Extract Atoms - To:
    yearTo = substring(to, 1, 4)
    monthTo = as.character(as.integer(substring(to, 6, 7))-1)
    dayTo = substring(to, 9, 10)

    # Compose Query:
    Query = paste("s=", query, "&a=", monthFrom, "&b=", dayFrom,
        "&c=", yearFrom, "&d=", monthTo, "&e=", dayTo, "&f=", yearTo,
        "&g=", aggregation, "&x=.csv", sep = "")

    # Source:
    if (is.null(source))
        source = "http://chart.yahoo.com/table.csv?"

    # Download:
    if (try) {
        # First try if the Internet can be accessed:
        z = try(yahooImport(query, file, source, frequency, from, to,
            nDaysBack, save, sep, try = FALSE))
        if (inherits(z, "try-error") || inherits(z, "Error")) {
            return("No Internet Access")
        } else {
            return(z)
        }
    } else {
        # Download File:
        frequency = freq
        url = paste(source, Query, sep = "")
        tmp <- tempfile()
        download.file(url = url, destfile = tmp)

        # Read data and revert:
        X = as.timeSeries(read.table(tmp, header = TRUE, sep = ","))
    }

    # Save to file:
    if (save) {
        write.table(as.data.frame(X), file = file, sep = sep)
    } else {
        unlink(file)
    }

    # Result:
    ans = new("fWEBDATA",
        call = match.call(),
        param = c(
            "Instrument" = query,
            "Frequency " = frequency),
        data = X,
        title = "Data Import from www.yahoo.com",
        description = description() )

    # Return Value:
    ans
}


# ------------------------------------------------------------------------------


yahooSeries <-
    function(symbols, from = NULL, to = Sys.timeDate(), nDaysBack = 366, ...)
{
    # A function implemented by Diethelm Wuertz

    # Description:
    #   Downloads easily time series data from Yahoo

    # Arguments:
    #   symbols - a character vector of symbol names
    #   from - from date
    #   to - to date
    #   nDaysBack - number of n-days back
    #   ... - arguments passed to the *Import()

    # Examples:
    #   yahooSeries("IBM", nDaysBack = 10)
    #   yahooSeries("IBM", frequency = "weekly")
    #   yahooSeries(c("^DJI", "IBM"))
    #   yahooSeries(c("^DJI", "IBM"), frequency = "monthly")

    # FUNCTION:

    # Download:
    X = yahooImport(query = symbols[1], ...)@data
    colnames(X) <- paste(symbols[1], colnames(X), sep = ".")
    N = length(symbols)
    if (N > 1) {
        for (i in 2:N) {
            Y = yahooImport(query = symbols[i], ...)@data
            colnames(Y) <- paste(symbols[i], colnames(Y), sep = ".")
            X = merge(X, Y)
        }
    }

    # Time Window:
    if (is.null(from)) from = to - nDaysBack*24*3600
    X = window(X, from, to)

    # Return Value:
    X
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org

################################################################################
# FUNCTION:             DESCRIPTION:
#  read.xls              Downloads an xls file and converts it in a csv file
################################################################################


read.xls <- 
function(url, sheet=1, lines=-1, verbose=FALSE, encoding="unknown")
{
    # Description:
    #   Downloads an xls and converts it in a csv file
    
    # Arguments:
    #   url - a character string specifying the URL
    #   sheet - an integer denoting whih sheet should be extracted
    #   lines - a negative integer with the lines to be skipped
    #   verbose - a logical decides about verbose mode
    #   encoding - a character string with the type of encodeing
    
    # Example:
    #   read.xls("http://www.jrsainfo.org/jabg/state_data2/Tribal_Data00.xls")
    
    # FUNCTION:
    
    # Download:
    con <- .xls2csv(url, sheet, verbose)
    ans = readLines(con, n = lines, encoding = encoding)
    ans = gsub('"', "", ans)
    file.remove(summary(con)$description)
    
    # Verbose ?
    if(verbose) print(ans)

    # Return Value:
    invisible(ans)
}


################################################################################
 

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received A copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# FUNCTION:               DESCRIPTION:
#  composeURL              Compose URL from partial strings
#  indexGrep               Greps Lines given a pattern
################################################################################


composeURL <- 
function(..., prefix = "http://")
{
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Compose URL from partial strings
    
    # FUNCTION:
    
    # Return Value:
    paste(prefix, ..., sep = "")
}


# ------------------------------------------------------------------------------


indexGrep <- 
function(pattern, x, ...)
{
    # A function implemented by Diethelm Wuertz
    
    # Description:
    #   Greps Lines given a pattern
    
    # FUNCTION:
    
    # Return Value:
    x[grep(pattern, x, ...)]
}


################################################################################

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General 
# Public License along with this library; if not, write to the 
# Free Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
# MA  02111-1307  USA

# Copyrights (C) for this R-port:
#   1999 - 2012 Diethelm Wuertz, Zurich, <wuertz@itp.phys.ethz.ch>
#   2009 - 2012 Rmetrics Association, Zurich, www.rmetrics.org


################################################################################
# INTERNAL:                 DESCRIPTION:
#  .getYahooData             Downloads time series data from yahoo finance
#  yahooBriefing             Downloads briefings from Yahoo's Internet site
#  yahooKeystats             Downloads key statistics from Yahoo's web site
################################################################################


.getYahooData <-
function(
    symbol, 
    start = format(Sys.Date()-366, format = "%Y%m%d"),
    end = format(Sys.Date(), format = "%Y%m%d"), 
    freq = c("daily", "weekly", "monthly"),
    type = c("price", "split"), 
    adjust = TRUE,
    quiet = TRUE) 
{
    # A copy of a function implemented by Josh Ulrich
    
    # Description:
    #   Downloads time series data from yahoo finance
    
    # Arguments:
    #   symbol - character, instrument symbol
    #   start - numeric, starting date, in ISO-8601 format as ccyymmdd,
    #       default is series' first date)
    #   end - numeric, ending date, in ISO-8601 format as ccyymmdd,
    #       default is today
    #   freq - character, frequency of data
    #       either 'daily', 'weekly', 'monthly'
    #   type - character, either 'price' or 'split'
    #   adjust - ogical, adjusts the Open, High, Low, and Close prices 
    #       for dividends and splits, and adjusts Volume for dividends.
    
    # References:
    #   http://help.yahoo.com/l/us/yahoo/finance/quotes
    #   http://help.yahoo.com/l/us/yahoo/finance/quotes/quote-12.html
    #   http://ichart.finance.yahoo.com/x?s=MSFT&g=d&y=0&z=30000
    
    # Examples:
    #   ans = .getYahooData("IBM"); colnames(ans)
    #         "Date"  "Open" "High" "Low"    "Close"   "Volume" 
    #         "Unadj.Close"  "Div"  "Split"  "Adj.Div"  
    #   ans = .getYahooData("IBM", type = "split"); colnames(ans)
    #         "Date" "Div" "Split" "Adj.Div"
    
    # Note:
    #   DW:
    #       This is Josh's function "getYahooData()" for udjusted prices and 
    #       dividends+splits. We rename his function to ".getYahooData()" 
    #       leave it untouched, and use the wrappers around it ...
    #   JU:
    #       Thank you to Giorgio Beltrame for the URL to download dividends 
    #       _and_ splits, and for his correct adjustment procedure.
    #       Many thanks to Ion Georgiadis for helpful suggestions and testing.
    #   DW:
    #       Modifications:
    #           function renamed to .getYahooData
    #           description added
    #           examples added
    #           argument matching added
    #           attribute "update" added
    #           code shortened to max 80 characters per line
    
    # Author:
    #   Package: TTR
    #   Type: Package
    #   Title: Technical Trading Rules
    #   Version: 0.14-0
    #   Date: 2008-01-23
    #   Author: Josh Ulrich
    #   Maintainer: Josh Ulrich <josh.m.ulrich@gmail.com>
    #   Enhances: quantmod
    #   Description: Functions and data to construct technical trading rules  
    #   License: GPL-3 
    
    # FUNCTION:

    # Match Arguments:
    freq = match.arg(freq)
    type = match.arg(type)
    
    # Check Dates:
    if (missing(start)) {
        beg <- as.POSIXlt( "1900-01-01" )
    } else {
        beg <- as.POSIXlt( as.Date( as.character(start), "%Y%m%d" ) )
    }
    if (missing(end)) {
        end <- as.POSIXlt(Sys.Date())
    } else {
        end <- as.POSIXlt( as.Date( as.character( end ), "%Y%m%d" ) )
    }

    if( beg > end ) stop("Start date must be before end date.")
    if( beg > as.POSIXlt(Sys.Date()) ) stop("Start date is after today's date.")

    # Get freqeucy and type parameters
    freq <- match.arg( freq, c("daily","weekly","monthly") )
    type <- match.arg( type, c("price","split") )
    
    
    if(type == "price") {
        freq.url <- substr(freq,1,1)
    } else {
        freq.url <- "v"
        if(freq!="daily" & !quiet) 
            message("Only freq=\"daily\" data available for type=\"split\".\n",
                "Setting freq=\"daily\"...")
    }
    
    flush.console()

    if(type == "price") {

        if(adjust) {
    
          if(freq == "daily") {
    
            # Get price, dividend, and split data from 'beg' to present
            ohlc   <- .getYahooData(symbol, start, freq="daily", type = "price",
                adjust = FALSE, quiet = TRUE)
            divspl <- .getYahooData(symbol, start, freq="daily", type = "split",
                adjust = FALSE, quiet = TRUE)
            ohlc   <- merge(ohlc, divspl, by.col="Date", all = TRUE)
    
            # Create split adjustment ratio, (always = 1 if no splits exist)
            s.ratio <- rep(1, NROW(ohlc))
            if( !all( is.na(ohlc$Split) ) ) {
              # Start loop at most recent data
              for( i in NROW(ohlc):2 ) {
                if( is.na( ohlc$Split[i] ) ) {
                  s.ratio[i-1] <- s.ratio[i]
                } else {
                  s.ratio[i-1] <- s.ratio[i] * ohlc$Split[i]
                } 
              }
            }
    
            # Un-adjust dividends for Splits
            ohlc$Div <- ohlc$Adj.Div * ( 1 / s.ratio )
    
            # Create dividend adjustment ratio, 
            #   (always = 1 if no dividends exist)
            d.ratio <- rep(1, NROW(ohlc))
            if( !all( is.na(ohlc$Adj.Div) ) ) {
                # Start loop at most recent data
                for( i in NROW(ohlc):2 ) {
                    if( is.na( ohlc$Adj.Div[i] ) ) {
                        d.ratio[i-1] <- d.ratio[i]
                    } else {
                        d.ratio[i-1] <- d.ratio[i] * ( 1 - ohlc$Div[i] / 
                            ohlc$Close[i-1] ) 
                    } 
                }
            }
    
            # Adjust OHLC and volume
            ohlc$Unadj.Close <- ohlc$Close
            ohlc$Open   <- ohlc$Open  * d.ratio * s.ratio
            ohlc$High   <- ohlc$High  * d.ratio * s.ratio
            ohlc$Low    <- ohlc$Low   * d.ratio * s.ratio
            ohlc$Close  <- ohlc$Close * d.ratio * s.ratio
            ohlc$Volume <- ohlc$Volume * ( 1 / d.ratio )
    
            # Order columns
            ohlc <- ohlc[,c("Date","Open","High","Low","Close","Volume",
                            "Unadj.Close","Div","Split","Adj.Div")]
    
        } else {
            stop("Only freq=\"daily\" adjusted data is currently supported.")
        }
    
        # For other frequencies, get daily data and use a routine to
        # aggregate to desired frequency.
    
        } else {
    
            # Construct URL for 'beg' to 'end'
            url <- paste( 
                "http://ichart.finance.yahoo.com/table.csv?s=", symbol,
                "&a=", beg$mon, 
                "&b=", beg$mday, 
                "&c=", beg$year+1900,
                "&d=", end$mon, "&e=", end$mday, 
                "&f=", end$year+1900,
                "&g=", freq.url, "&ignore=.csv", sep="" )
        
            # Fetch data:
            ohlc <- read.table(url, header=TRUE, sep=",")
            ohlc$Date <- as.Date(as.character(ohlc$Date), "%Y-%m-%d")
            ohlc$Adj.Close <- NULL
    
        }

    } else {

        if(!quiet) 
            message("Unadjusted and adjusted dividend data are always returned.")

        # Construct URL for 'beg' to 'end'
        url <- paste( "http://ichart.finance.yahoo.com/x?s=", symbol,
                    "&a=", beg$mon, "&b=", beg$mday, "&c=", beg$year+1900,
                    "&d=", end$mon, "&e=", end$mday, "&f=", end$year+1900,
                    "&g=", freq.url, "&y=0&z=30000", sep="" )

        # Fetch data
        ohlc <- read.table(url, skip=1, sep=",", fill=TRUE, as.is=TRUE)
        div  <- data.frame( Date=   ohlc$V2[ohlc$V1=="DIVIDEND"],
                          Adj.Div=as.numeric(ohlc$V3[ohlc$V1=="DIVIDEND"]),
                          stringsAsFactors=FALSE )
        spl  <- data.frame( Date=   ohlc$V2[ohlc$V1=="SPLIT"],
                          Split=as.character(ohlc$V3[ohlc$V1=="SPLIT"]),
                          stringsAsFactors=FALSE )

        ohlc <- merge(div, spl, by.col="Date", all=TRUE)
        ohlc$Date <- as.Date(as.character(ohlc$Date), "%Y%m%d")

        # Create split adjustment ratio, (always = 1 if no splits exist)
        s.ratio <- rep(1, NROW(ohlc))
        if(NROW(spl)!=0) {
            ohlc$Split <- sub(":","/", ohlc$Split)
            ohlc$Split <- 1 / sapply( parse( text=ohlc$Split ), eval )
            # Start loop at most recent data
            for( i in NROW(ohlc):2 ) {
                if( is.na( ohlc$Split[i] ) ) {
                    s.ratio[i-1] <- s.ratio[i]
                } else {
                    s.ratio[i-1] <- s.ratio[i] * ohlc$Split[i]
                } 
            }   
        }

        # Un-adjust dividends for Splits
        ohlc$Div <- ohlc$Adj.Div * ( 1 / s.ratio )
        ohlc$Split <- as.numeric(ohlc$Split)

        # Order data columns
        ohlc <- ohlc[,c("Date","Div","Split","Adj.Div")]

        # Return (empty) data
        if(NROW(ohlc)==0) return(ohlc)
    }

    # Order Dates, and only return requested data (drop 'end' to present)
    ohlc <- ohlc[order(ohlc$Date),]
    row.names(ohlc) <- 1:NROW(ohlc)
    ohlc <- ohlc[ ( ohlc$Date >= as.Date(beg) & ohlc$Date <= as.Date(end) ), ]

    ### Check to see if supplied dates occur in data set
    if( max(ohlc$Date) != as.Date(end) ) {
        if(!quiet) message("End date out of range, "  , max(ohlc$Date), 
            " is last available date.")
    }
    if( min(ohlc$Date) != as.Date(beg) ) {
        if(!quiet) message("Start date out of range, ", min(ohlc$Date), 
            " is first available date.")
    }
       
    # Add Attributes:
    attr(ohlc, "update") <- format(Sys.time())

    # Return Value:
    return(ohlc)
}


###############################################################################


yahooBriefing <-
    function (query, file = "tempfile", source = NULL,
    save = FALSE, try = TRUE)
{
    # A function implemented by Diethelm Wuertz and Matthew C.Keller

    # Description:
    #   Downloads Key Statistics on shares from Yahoo's Internet site

    # Imortant Note:
    #   This function is no longer supported. The reason for this
    #   are the too many changes on the Yhaoo web site which made 
    #   the download very prone to many failures. Feel free to use
    #   the code here to adapt the function to your own needs.
    #   DW: Match 14, 2012
       
    # Example:
    #   yahooBriefing("YHOO")
    #   yahooBriefing("IBM")

    # FUNCTION:

    # Important Note:
    cat("\n")
    cat("This function is no longer supported. The reason for this\n")
    cat("are the too many changes on the Yhaoo web site which made\n")
    cat("the download very prone to many failures. Feel free to use\n")
    cat("the code here to adapt the function to your own needs.\n")
    cat("\n")
    return()
    
    # Download:
    if (is.null(source))
        source = "http://finance.yahoo.com/q/ud?s="
    if (try) {
        # First try if the Internet can be accessed:
        z = try(yahooBriefing(query, file, source, save, try = FALSE))
        if (class(z) == "try-error" || class(z) == "Error") {
            return("No Internet Access")
        }
        else {
            return(z)
        }
    } else {
        # Download:
        url = paste(source, query, sep = "")
        download.file(url = url, destfile = file)
        x = scan(file, what = "", sep = "\n")

        # Extract Data Records:
        x = x[grep("Briefing.com", x)]

        x = gsub("</", "<", x, perl = TRUE)
        x = gsub("/", " / ", x, perl = TRUE)
        x = gsub(" class=.yfnc_tabledata1.", "", x, perl = TRUE)
        x = gsub(" align=.center.", "", x, perl = TRUE)
        x = gsub(" cell.......=...", "", x, perl = TRUE)
        x = gsub(" border=...", "", x, perl = TRUE)
        x = gsub(" color=.red.", "", x, perl = TRUE)
        x = gsub(" color=.green.", "", x, perl = TRUE)
        x = gsub("<.>", "", x, perl = TRUE)
        x = gsub("<td>", "@", x, perl = TRUE)
        x = gsub("<..>", "", x, perl = TRUE)
        x = gsub("<...>", "", x, perl = TRUE)
        x = gsub("<....>", "", x, perl = TRUE)
        x = gsub("<table>", "", x, perl = TRUE)
        x = gsub("<td nowrap", "", x, perl = TRUE)
        x = gsub("<td height=....", "", x, perl = TRUE)
        x = gsub("&amp;", "&", x, perl = TRUE)

        x = unlist(strsplit(x, ">"))

        x = x[ grep("-...-[90]", x, perl = TRUE) ]
        nX = length(x)
        # The last record has an additional @, remove it ...
        x[nX] = gsub("@$", "", x[nX], perl = TRUE)
        x = unlist(strsplit(x, "@"))
        x[x == ""] = "NA"
        x = matrix(x, byrow = TRUE, ncol = 9)[, -c(2,4,6,8)]
        x[, 1] = as.character(strptime(x[, 1], format = "%d-%b-%y"))
        colnames(x) = c("Date", "ResearchFirm", "Action", "From", "To")
        x = x[nrow(x):1, ]
        X = as.data.frame(x)
    }

    # Return Value:
    X
}


###############################################################################



yahooKeystats <-
    function (query, file = "tempfile", source = NULL,
    save = FALSE, try = TRUE)
{
    # A function implemented by Diethelm Wuertz and Matthew C.Keller

    # Description:
    #   Downloads Key Statistics on shares from Yahoo's Internet site

    # Imortant Note:
    #   This function is no longer supported. The reason for this
    #   are the too many changes on the Yhaoo web site which made 
    #   the download very prone to many failures. Feel free to use
    #   the code here to adapt the function to your own needs.
    #   DW: Match 14, 2012
       
    # Example:
    #   yahooKeystats("YHOO")
    #   yahooKeystats("IBM")

    # Changes:
    #   2006-08-26 update by MCK

    # FUNCTION:
    
    # Important Note:
    cat("\n")
    cat("This function is no longer supported. The reason for this\n")
    cat("are the too many changes on the Yhaoo web site which made\n")
    cat("the download very prone to many failures. Feel free to use\n")
    cat("the code here to adapt the function to your own needs.\n")
    cat("\n")
    return()
    
    # Download:
    if (is.null(source))
        source = "http://finance.yahoo.com/q/ks?s="
    if (try) {
        # First try if the Internet can be accessed:
        z <- try(yahooKeystats(query, file, source, save, try = FALSE))
        if (inherits(z, "try-error") || inherits(z, "Error"))
            paste("The query", query,
                  "gave an error. Maybe no internet access?",
                  sep = "  \n")
        else
            z

    } else {
        # Download and Scan:
        url = paste(source, query, sep = "")
        download.file(url = url, destfile = file)
        x = scan(file, what = "", sep = "\n")

        # Extract Data Records:
        x = x[grep("datamodoutline1", x)]

        # YC: 2009-03-31
        # if keystats are not available, returns NA
        if (!length(x)) return(NA)

        # Clean up HTML:
        x = gsub("/", "", x, perl = TRUE)
        x = gsub(" class=.yfnc_datamodoutline1.", "", x, perl = TRUE)
        x = gsub(" colspan=.2.", "", x, perl = TRUE)
        x = gsub(" cell.......=...", "", x, perl = TRUE)
        x = gsub(" border=...", "", x, perl = TRUE)
        x = gsub(" class=.yfnc_tablehead1.", "", x, perl = TRUE)
        x = gsub(" class=.yfnc_tabledata1.", "", x, perl = TRUE)
        x = gsub(" width=.75%.>", "", x, perl = TRUE)
        x = gsub(" width=.100%.", "", x, perl = TRUE)
        x = gsub(" size=.-1.", "", x, perl = TRUE)
        x = gsub("<.>", "", x, perl = TRUE)
        x = gsub("<..>", "", x, perl = TRUE)
        x = gsub("<....>", "", x, perl = TRUE)
        x = gsub("<table>", "", x, perl = TRUE)
        x = gsub("<sup>.<sup>", "", x, perl = TRUE)
        x = gsub("&amp;", "&", x, perl = TRUE)
        x = gsub("<td", " @ ", x, perl = TRUE)
        x = gsub(",", "", x, perl = TRUE)

        # Create Matrix:
        x = unlist(strsplit(x, "@" ))
        x = x[ grep(":", x) ]
        x = gsub("^ ", "", x, perl = TRUE)
        if (length(Index <- grep("^ ", x)) > 0)
            x <- x[-Index]
        x = gsub(" $", "", x, perl = TRUE)
        x = gsub(":$", ":NA", x, perl = TRUE)

        # If there are two ":" in a line ...
        x = sub(":", "@", x)
        x = sub(":", "/", x)

        # Convert to matrix:
        x = matrix(x, byrow = TRUE, ncol = 2)

        # Add Current Date:
        stats = as.character(Sys.Date())
        x = rbind(c("Symbol", query), c("Date", stats), x)
        X = as.data.frame(x[, 2])
        rownames(X) = x[, 1]
        colnames(X) = "Value"

        ## Return Value:
        X
    }
}


################################################################################

\name{import-yahoo}

\alias{import-yahoo}

\alias{yahooImport}
\alias{yahooSeries}


\title{Import Market Data from Yahoo}


\description{
    
    Imports financial time series data from chart.yahoo.com.
   
}


\usage{ 
yahooSeries(symbols, from = NULL, to = Sys.timeDate(), 
    nDaysBack = 366, \dots) 
    
yahooImport(query, file = "tempfile", source = NULL,
    frequency = c("daily", "weekly", "monthly"), 
    from = NULL, to = Sys.timeDate(), nDaysBack = 366, 
    save = FALSE, sep = ";", try = TRUE) 
}


\arguments{

    \item{file}{
        a character string with filename, usually having extension 
        ".csv", where to save the downloaded data.
        }
    \item{frequency}{
        a character string, one of "auto", "quarterly", "monthly", 
        or "daily", defining the frequency of the data records.
        Note, the import function tries autodetect the frequency
        of the time series to be dowwnloaded. This may fail, in
        such case specify the frequency explicitely.
        }
    \item{from}{
        the date from when to extract the time series.
        }
    \item{nDaysBack}{
        the number of days back.
        }
    \item{query}{
        a character string, denoting the location of the data at the 
        web site.
        }
    \item{save}{
        a logical value, if set to TRUE the downloaded data file will 
        be stored under the path and file name specified by the
        string \code{file}. By default FALSE.
        }
    \item{sep}{
        a charcter value specifying the column separator.
        }
    \item{source}{a character string setting the URL of the source.
        If \code{NULL}, then the URL will be set automatically to its
        default value.
        }
    \item{symbols}{
        a character string with the symbols to be downloaded.
        }
    \item{to}{
        the end date of the data download, by default the current 
        date.
        }
    \item{try}{
        a logical value, if set to TRUE the Internet access will be
        checked.
        }
    \item{\dots}{
        optional arguments to be passed.
        }
        
}
  
  
\value{

    The function \code{yahooImport} returns an S4 object of class 
    \code{fWEBDATA} with the following slots:
    
    \item{@call}{
        the function call.  
        }
    \item{@data}{
        the data as downloaded formatted as a data.frame.
        }
    \item{@param}{
        a character vector whose elements contain the values of selected 
        parameters of the argument list.
        }
    \item{@title}{
        a character string with the name of the download. This can be 
        overwritten specifying a user defined input argument.
        }
    \item{@description}{
        a character string with an optional user defined description. 
        By default just the current date when the test was applied will
        be returned.}
        
    The function \code{yahooSeries} returns an S4 object of 
    class  \code{timeSeries} or alternatively an object specified by
    the function argument \code{returnClass}.
    \cr
    
    The function \code{keystatsImport} returns a data frame with 
    key statistics downloaded from yahoo's web site.
    
}


\details{
  
    \bold{Import data from chart.yahoo.com:}
    \cr\cr
    
    The query string is given as 
    \cr\cr
            \code{s=SYMBOL&a=DD&b=MM&c=CCYY&g=d&q=q&z=SYMBOL&x=.csv} 
    \cr\cr
    where \code{SYMBOL} has to replaced by the symbol name of the 
    instrument, and \code{DD}, \code{MM}, and \code{CCYY} by the 
    day, month-1 and century/year when the time series should start.

    Here are some examples of symbols:

    \tabular{ll}{
    \code{[query]}  \tab Description: \cr
                    \tab \cr
    \code{^DJI}     \tab Dow Jones 30 Industrial Averages \cr
    \code{^NYA}     \tab New York Stock Exchange Composite \cr
    \code{^NDX}     \tab Nasdaq 100 Index \cr
    \code{^IXIC}    \tab Nasdaq Composite Index \cr
    \code{^TYX}     \tab US 30Y Treasury Bond Index \cr
    \code{IBM}      \tab BM DJIA Stock \cr
    \code{KO}       \tab Coca-Cola DJIA Stock }

    The meaning of the tokens in the query string are the following:

    \tabular{ll}{
    Token           \tab Description  \cr
                    \tab \cr
    \code{s}        \tab Selected Ticker-Symbol \cr
    \code{a}        \tab First Quote starts with Month (mm) \cr
    \code{b}        \tab First Quote starts with Day (dd) \cr
    \code{c}        \tab First Quote starts with Year (ccyy) \cr
    \code{d}        \tab Last Quote ends with Month (mm) \cr
    \code{e}        \tab Last Quote ends with Day (dd) \cr
    \code{f}        \tab Last Quote ends with Year (ccyy) \cr
    \code{z}        \tab Selected Ticker-Symbol }
            
}


\note{
  
    \bold{Internet Download Functions:}
    
    IMPORTANT NOTE: If the service provider changes the data file format 
    it may become necessary to modify and update the functions. 
    
    Feel free to inspect the code of the functions and to create your
    own download function from other Internet web sites and Portals.
     
}


\seealso{
       
    Two further download functions \code{\link{fredImport}} and 
    \code{\link{oandaImport}} allow to import data from the U.S.
    Federal Reserve and from Oanda.
     
}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\examples{
yahooImport("^GDAXI")
yahooSeries("^GDAXI")
}


\keyword{data}

\name{read-split}


\alias{charvecSplit}
\alias{dataSplit}


\title{Splitting downloaded data sets}


\description{

    Two helpful data set and charvec splitting utilities. 
    
}


\usage{
dataSplit(x, split=" ", col=-1)
charvecSplit(x, split=" ", col=1, format="\%F")
}


\arguments{

    \item{x}{
        character vector to be splitted. 
    }
    \item{split}{
        the split character, by default a blank.
    }
    \item{col}{
        an integer value or vector, the columns to be selected.
    }
    \item{format}{
        the date format of the character vector, by default
        the ISO-8601 date format.
    }
}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\keyword{programming}

\name{read-w3m}
\alias{read.w3m}


\title{w3m Browser interface}

\description{
  Uses the w3m Browser to read a web page. 
}

\usage{
read.w3m(url, intern = TRUE, bin = NULL, pipe = FALSE, \dots)
}

\arguments{

  \item{url}{
    a character string specifying the URL of the web page.
  }
  \item{intern}{
    a logical which indicates whether to make the output 
    of the command an R object. 
  }
  \item{bin}{
    a string with the path of your w3m binary or NULL if w3m
    binary is available in the operating system path.
  }
  \item{pipe}{
    a logical which indicates whether the result should be returned
    as a \code{pipe()} commmand.
  }
  \item{\dots}{
    optional arguments passed to w3m binary. 
    For a list of options, see the w3m manual page.
  }
}

\value{
    the downloaded text
}

\references{
  Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
  \emph{Financial Market Data for R/Rmetrics}, 
  Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
  www.rmetrics.org.
}

\seealso{
       
  Alternative text browser functions are the Rmetrics functions
  \code{\link{read.links}} and \code{\link{read.lynx}}.
   
  To download \code{xls} and \code{xlsx} spread sheets use the
  functions \code{gdata::read.xls} and \code{xlsx::read.xlsx} 
  from the contributed packages \code{gdata} and \code{xlsx}, 
  respectively.
  
  To download text files line by line use the Rmetrics function
  \code{\link{read.lines}} which wraps the function \code{readLines}
  from R's base evironment.
  
  To postprocess downloaded files use the Rmetrics functions
  \code{\link{indexGrep}}, \code{\link{dataSplit}}, 
  \code{\link{charvecSplit}}, and \code{\link{stringSplit}}.
    
}

\keyword{programming}

\name{utils-yahooBriefing}


\alias{yahooBriefing}


\title{Import Briefings from Yahoo}


\description{
    
    Imports briefings from chart.yahoo.com.
   
}


\usage{ 
yahooBriefing(query, file = "tempfile", source = NULL, save = FALSE, try = TRUE) 
}


\arguments{

    \item{file}{
        a character string with filename, usually having extension 
        ".csv", where to save the downloaded data.
        }
    \item{query}{
        a character string, denoting the location of the data at the 
        web site.
        }
    \item{save}{
        a logical value, if set to TRUE the downloaded data file will 
        be stored under the path and file name specified by the
        string \code{file}. By default FALSE.
        }
    \item{source}{a character string setting the URL of the source.
        If \code{NULL}, then the URL will be set automatically to its
        default value.
        }
    \item{try}{
        a logical value, if set to TRUE the Internet access will be
        checked.
        }
        
}
  
  
\value{

    returns a data frame with briefings downloaded from yahoo's web site.
    
}


\note{

    This function is no longer supported. The reason for this
    are the too many changes on the Yhaoo web site which made
    the download very prone to many failures. Feel free to use
    the code here to adapt the function to your own needs.

}


\author{

    Diethelm Wuertz for the Rmetrics \R-port.
    
}


\references{

    Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\keyword{data}

\name{utils-download}

\alias{composeURL}
\alias{indexGrep}

\title{Utilities for composing URL's}

\description{
    Two helpful utilities for assembling URL's.
}

\usage{
composeURL(\dots, prefix="http://")
indexGrep(pattern, x, \dots)
}

\arguments{

  \item{\dots}{
    for \code{composeURL}, character strings from which the URL will
    be composed; for \code{indexGrep}, optional arguments to be
    passed to the function \code{grep}.
  }

  \item{prefix}{
    a character string specifying the prefix of the URL.
  }

  \item{pattern}{
    a character string containing a regular expression to be matched in
    the given character vector.
  }

  \item{x}{
    a character vector where matches are sought.
  }
}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}

\keyword{programming}

\name{utils-yahooBriefing}


\alias{yahooBriefing}


\title{Import Briefings from Yahoo}


\description{
    
    Imports briefings from chart.yahoo.com.
   
}


\usage{ 
yahooBriefing(query, file = "tempfile", source = NULL, save = FALSE, try = TRUE) 
}


\arguments{

    \item{file}{
        a character string with filename, usually having extension 
        ".csv", where to save the downloaded data.
        }
    \item{query}{
        a character string, denoting the location of the data at the 
        web site.
        }
    \item{save}{
        a logical value, if set to TRUE the downloaded data file will 
        be stored under the path and file name specified by the
        string \code{file}. By default FALSE.
        }
    \item{source}{a character string setting the URL of the source.
        If \code{NULL}, then the URL will be set automatically to its
        default value.
        }
    \item{try}{
        a logical value, if set to TRUE the Internet access will be
        checked.
        }
        
}
  
  
\value{

    returns a data frame with 
    briefings downloaded from yahoo's web site.
    
}


\author{
    Diethelm Wuertz for the Rmetrics \R-port.
}


\references{
Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\keyword{data}

\name{class-fWEBDATA}
\alias{fWEBDATA-class}

\docType{class}

\title{Class "fWEBDATA"}

\description{ 
  The class fWEBDATA represents a time series downloaded from the
  internet.
}

\section{Objects from the Class}{
  Objects can be created by calls of the import or series functions.
}

\section{Slots}{
  \describe{
    \item{\code{call}:}{Object of class \code{"call"}: 
      the call of the applied function.
    } 
    \item{\code{data}:}{Object of class \code{"data.frame"}:
      the downloaded data formatted as a \code{"timeSeries"} object.
    }
    \item{\code{param}:}{Object of class \code{"character"}:
      a character vector whose elements contain the values of selected 
      parameters of the argument list.
    }
    \item{\code{title}:}{Object of class \code{"character"}:
      a character string with the name of the download. This can be 
      overwritten specifying a user defined input argument.
    }
    \item{\code{description}:}{Object of class \code{" character"}:
      a character string with an optional user defined description. 
      By default just the current date and user when the test was 
      applied will be returned.
    }
  }
}       

\section{Methods}{
  \describe{
    \item{show}{\code{signature(object = "fWEBDATA")}: 
      prints an object of class 'fWEBDATA'. 
    }
  }
}

\note{

  The import and series functions like \code{\link{fredImport}} and
  \code{\link{fredSeries}} are typical examples which show how to
  implement download functions as simple \code{timeSeries} objects or as
  more complicate \code{fWEBDATA} S4 objects. Inspect the R code and
  feel free to create your own download functions and objects.

}

\references{
  Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
  \emph{Financial Market Data for R/Rmetrics}, 
  Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
  www.rmetrics.org.
}

\seealso{
  \code{\link{fredImport}},
  \code{\link{fredSeries}},
}

\keyword{data}

\name{utils-split}

\alias{charvecSplit}
\alias{dataSplit}
\alias{stringSplit}

\title{Split downloaded data sets}

\description{

    Helpful dataset and charvec splitting utilities. 
    
}


\usage{
dataSplit(x, split=" ", col=-1)
charvecSplit(x, split=" ", col=1, format="\%F")
stringSplit(x, split=" ", col=NULL) 
}

\arguments{

    \item{x}{
        character vector to be splitted. 
    }
    \item{split}{
        the split character, by default a blank.
    }
    \item{col}{
        an integer value or vector, the column(s) to be selected.
    }
    \item{format}{
        the date format of the character vector, by default
        the ISO-8601 date format.
    }
}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}

\keyword{programming}

\name{read-download}


\alias{composeURL}
\alias{indexGrep}


\title{Download Utilities}


\description{

    Twp helpful utilities to read downloads.\ 
    
}


\usage{
composeURL(\dots, prefix="http://")
indexGrep(pattern, x, \dots)
}


\arguments{

    \item{\dots}{
        [composeURL]\cr
        character strings from which the URL will be composed.\cr
        [indexGrep]\cr
        optional arguments to be passed to the function \code{grep}.  
    }
    \item{prefix}{
        a character string specifying the prefix of the URL.
    }
    \item{pattern}{
        a character string containing a regular expression to be 
        matched in the given character vector. 
    }
    \item{x}{
        a character vector where matches are sought.
    }
    
}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\keyword{programming}

\name{utils-yahooKeystats}


\alias{yahooKeystats}


\title{Import Key Statistics Data from Yahoo}


\description{

  Imports key statistics data from \verb{chart.yahoo.com}.
  
}


\usage{
yahooKeystats(query, file = "tempfile", source = NULL, save = FALSE, try = TRUE)
}


\arguments{
    \item{file}{a character string specifying a filename, usually having extension
      \file{".csv"}, where to save the downloaded data.}
    \item{query}{
        a character string, denoting the location of the data at the
        web site.
        }
    \item{save}{
        a logical value, if set to TRUE the downloaded data file will
        be stored under the path and file name specified by the
        string \code{file}. By default FALSE.
        }
    \item{source}{a character string setting the URL of the source.
        If \code{NULL}, then the URL will be set automatically to its
        default value.
        }
    \item{try}{logical indicating if the internet access will be checked.}
}


\value{
  returns a data frame (\code{\link{data.frame}}) with
  key statistics downloaded from yahoo's web site.
}


\author{
    Diethelm Wuertz for the Rmetrics \R-port.
}


\references{
  Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis (2010).
  \emph{Financial Market Data for R/Rmetrics};
  Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
  \url{www.rmetrics.org}.
}


\keyword{data}

\name{provider-Listings}


\alias{providerListings}

\alias{amexListing}
\alias{h15Listing}
\alias{nasdaqListing}
\alias{nyseListing}
\alias{oandaListing}
\alias{stoxxListing}
\alias{swxListing}


\title{Provider Listing of Symbols and Descriptions} 


\description{

    CSV files with provider listings of symbols, descriptions
    ands related information.
    
    The listings include those from:
    
    \tabular{ll}{
        amexListing      \tab Listing from the American Stock Exchange\cr
        h15Listing       \tab Listing from the FED H15 Report\cr
        nasdaqListing    \tab Listing from the NASDAQ Stock Market\cr
        nyseListing      \tab Listing from the New York Stock Exchange\cr
        oandaListing     \tab Listing of OANDAs Foreign Exchange Rates\cr
        stoxxListing     \tab Listing of STOXX Indices\cr
        swxListing       \tab Listing from the Swiss Stock Exchange\cr
    }
   
}


\format{
    
    All files are given in CSV Excel spreadsheet format. 
    The delimiter is a semicolon. 
    
}


\references{

    Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}

\examples{
data(package = "fImport")

head(h15Listing)
head(nyseListing)
}
 
\keyword{datasets}

\name{show-methods}
\alias{show-methods}

\docType{methods}

%\alias{show,ANY-method}
\alias{show,fWEBDATA-method}


\title{WEBDATA Download Show Methods}

\description{
  Show methods for WEBDATA downloads. 
}

\section{Methods}{
  \describe{

    \item{object = "fWEBDATA"}{
      Print function for objects of class \code{"fWEBDATA"}.
    }   
  }
}

\references{
  Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis (2010);
  \emph{Financial Market Data for R/Rmetrics}, 
  Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
  www.rmetrics.org.
}

\keyword{data}

\name{read-lines}


\alias{read.lines}


\title{Read from a text file line by line}


\description{

    Reads from a text file line by line. Wrapper to readLines()
    function.

}


\usage{
read.lines(con=stdin(), n=-1, ok=TRUE, warn=FALSE, encoding="unknown")
}


\arguments{

    \item{con}{
        a connection object or a character string.
    }
    \item{n}{
        an integer, the (maximal) number of lines to read.
        Negative values indicate that one should read up
        to the end of input on the connection.
    }
    \item{ok}{
        a logical, is it OK to reach the end of the connection
        before n > 0 lines are read? If not, an error will be
        generated.
    }
    \item{warn}{
        a logical, warn if a text file is missing a final EOL.
        The default is FALSE, note different from function
        \code{readLines}.
    }
    \item{encoding}{
        a character string, the encoding to be assumed for input
        strings.
    }
}


\value{

    the downloaded text. Same output as readLines() function.

}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics},
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.

}


\keyword{programming}

\name{import-fred}
\alias{import-fred}

\alias{fredImport}
\alias{fredSeries}

\concept{Federal Reserve Bank of St. Louis}
\concept{Federal Reserve}
\concept{FRED}
\concept{download time series}


\title{Import Market Data from the Federal Reserve Database}

\description{
    
  Imports financial time series data from fred.stlouisfed.org.
   
}

\usage{
fredSeries(symbols, from = NULL, to = Sys.timeDate(), 
    nDaysBack = 366, \dots)
    
fredImport(query, file = "tempfile", source = NULL, frequency = "daily", 
    from = NULL, to = Sys.timeDate(), nDaysBack = NULL,
    save = FALSE, sep = ";", try = TRUE)    
}

\arguments{
  \item{symbols}{
    a character string with the symbols to be downloaded.
  }
  \item{from}{
    the start date of the time series to extract.
  }
  \item{to}{
    the end date of the data download, by default the current date.
  }
  \item{nDaysBack}{
    the number of days back.
  }
  \item{\dots}{
    optional arguments to be passed to \code{fredImport}.
  }
  \item{query}{
    a character string, denoting the location of the data at the 
    web site.
  }
  \item{file}{
    where to save the downloaded data, a character string with filename,
    usually having extension ".csv".
  }
  \item{source}{
    a character string setting the URL of the source.  If \code{NULL},
    then the URL will be set automatically to its default value.
  }
  \item{frequency}{
    a character string, one of \code{"auto"}, \code{"quarterly"},
    \code{"monthly"}, or \code{"daily"}, defining the frequency of the
    data records.  Only needed if the import function fails to
    autodetect the frequency of the time series to be dowwnloaded.
  }
  \item{save}{
    a logical value, if set to \code{TRUE} the downloaded data file will be
    stored under the path and file name specified by the string
    \code{file}. By default FALSE.

  }
  \item{sep}{
    a character value specifying the column separator.
  }
  \item{try}{
    a logical value, if set to TRUE the Internet access will be checked.
  }
}

\value{
  for \code{fredSeries}, an object of class \code{timeSeries}.
  
  for \code{fredImport}, an object of class \code{fWEBDATA} with the
  following slots:
  \item{@call}{
    the function call.  
  }
  \item{@data}{
    the downloaded data as an object from class \code{"timeSeries"}.
  }
  \item{@param}{
    a character vector whose elements contain the values of selected 
    parameters of the argument list.
  }
  \item{@title}{
    a character string with the name of the download. This can be 
    overwritten specifying a user defined input argument.
  }
  \item{@description}{
    a character string with an optional user defined description. 
    By default just the current date when the test was applied will
    be returned.
  }
}

\note{
  
  \bold{Internet Download Functions:}
    
  IMPORTANT NOTE: If the service provider changes the data file format 
  it may become necessary to modify and update the functions. 
    
  Feel free to inspect the code of the functions and to create your
  own download function from other Internet web sites and Portals.
  
}

%\seealso{
%       
%    Two further download functions \code{\link{oandaImport}} and 
%    \code{\link{yahooImport}} allow to import data from Oanda and 
%    from Yahoo Finance.
%     
%}

\author{
  Diethelm Wuertz for the Rmetrics \R-port.
}

\references{
Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
}

\examples{
\donttest{
a <- fredImport("DEXSZUS")
head(a@data)  # a@data is a "timeSeries" object

b <- fredSeries("DEXSZUS")
head(b) # a "timeSeries" object
}
}
\keyword{data}
\keyword{ts}

\name{fImport-package}


\alias{fImport-package}
\alias{fImport}


\docType{package}


\title{Import data from the web}


\description{

    The Rmetrics "fImport" package is a collection of utility functions 
    to download and manage data sets from the Internet or from other 
    sources.
    
}


% \details{
% 
%     \tabular{ll}{
%         Package:    \tab fImport\cr
%         Type:       \tab Package\cr
%         Version:    \tab R 3.1.2\cr
%         Date:       \tab 2015\cr
%         License:    \tab GPL Version 2 or later\cr
%         Copyright:  \tab (c) 1999-2015 Rmetrics Assiciation\cr
%         URL:        \tab \url{https://www.rmetrics.org}
%     }
%     
% }


\section{1 Introduction}{
    
    The major content of this package is to provide download functions 
    for financial market data from the Internet. For this we have 
    implemented the web text browsers "Lynx", "Links", and "W3M"
    for an easy and straightforward download of data from the Internet.   
    
    Furthermore helpful utility functions are included to split numerical 
    data matrices, to split date character vectors, and to split strings 
    from downloads. This allows to create in a very easy way 
    \code{timeSeries} objects.
    
    Examples are provided for downloading data from the Federal Reserve
    data base in St. Louis web portal.
    % from Oanda FX, and from Yahoo Finance
    
    The data part contains instruments listings from the American Stock 
    Exchange, from the FED H15 Report, from the NASDAQ Stock Market,
    from the New York Stock Exchange, of OANDAs Foreign Exchange Rates,
    of STOXX Indices, and from the Swiss Stock Exchange.
       
    For the download of spread sheets from the Internet we refer to the 
    functions \code{gdata::read.xls} and \code{xlsx::read.xlsx} for the 
    contributed \R packages \code{gdata} and \code{xlsx} respectively.
    
}


\section{2 Download Functions}{

    The package makes functions available to download financial market
    data from the internet. Currently functions are available for the 
    follwing web sites. The functions are:
    
    \preformatted{
    fredSeries      downloads data from research.stlouisfed.org
    %oandaSeries     downloads data from www.oanda.com
    %yahooSeries     downloads data from chart.yahoo.com
    }
    
    The economic and financial time series data are extractes as objects 
    of class \code{"timeSeries"}.   

}


\section{3 Readers and Web downloaders}{

    The package comes with the following tailored readers and web 
    downloaders:
    
    \preformatted{
    read.lines      a synonym function call to readLines
    read.links      uses the links browser to read from a web page
    read.lynx       uses the lynx browser to read from a web page
    read.w3m        uses the w3m browser to read from a web page
    }

}


\section{4 Split Function Utilities}{

    This section provides functions to split numerical data matrices, 
    to split date character vectors, and to split strings 
    from downloads:
    
    \preformatted{
    dataSplit       splits a data matrix from a downloaded file
    charvecSplit    splits a charvec vector from a downloaded file
    stringSplit     splits a string vector from a downloaded file
    }

}


\section{About Rmetrics}{

    The \code{fImport} Rmetrics package is written for educational 
    support in teaching "Computational Finance and Financial Engineering" 
    and licensed under the GPL.
    
}


\keyword{package} 

\name{read-xls}


\alias{read.xls}


\title{Read from an xls file}


\description{

    Reads a sheet from an xls file. 
    
}


\usage{
read.xls(url, sheet=1, lines=-1, verbose=FALSE, encoding="unknown")
}
    
    
\arguments{

    \item{url}{
        a character string specifying the URL of the web page.
    }
    \item{sheet}{
        an integer denoting which sheet should be extracted,
        by default the first. 
    }
    \item{lines}{
        a negative integer with the lines to be skipped, by
        default the first.
    }
    \item{verbose}{
        a logical decides about verbose mode, by default FALSE.
    }
    \item{encoding}{
        a character string with the type of encoding, by
        defaul \code{"unknown"}.
    }
}


\value{

    the downloaded text.

}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\keyword{programming}

\name{read-lynx}


\alias{read.lynx}


\title{Lynx Browser interface}


\description{

    Uses the Lynx Browser to read a web page. 
    
}


\usage{
read.lynx(url, intern = TRUE, bin = NULL, pipe = FALSE, \dots)
}


\arguments{

    \item{url}{
        a character string specifying the URL of the web page.
    }
    \item{intern}{
        a logical which indicates whether to make the output 
        of the command an R object. 
    }
    \item{bin}{
        a string with the path of your lynx binary or NULL if lynx
        binary is available in the operating system path.
      }
      \item{pipe}{
    a logical which indicates whether the result should be returned
        as a \code{pipe()} commmand.
    }
    \item{\dots}{
        optional arguments passed to lynx binary. For example
        \code{accept_all_cookies = TRUE} or
        \code{cookie_file="~/.lynx_cookies"}. For a list of options, see
        the lynx manual page.
    }
}


\value{

    the downloaded text.

}


\references{

Diethelm Wuertz, Yohan Chalabi, and Andrew Ellis, (2010);
    \emph{Financial Market Data for R/Rmetrics}, 
    Rmetrics eBook, Rmetrics Association and Finance Online, Zurich,
    www.rmetrics.org.
    
}


\keyword{programming}
